package jp.co.melco.preserv.misc;

/*
  
  \J[\\Cxg

@}EXJ[\ʒuɏ\\܂B

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B

  copyright(c) MITSUBISHI ELECTRIC CORPORATION

*/

import java.awt.event.MouseEvent ;
import jp.co.melco.preserv.psvJavaScreen;
import jp.co.melco.preserv.psvJCanvas;
import jp.co.melco.preserv.misc.*;
import jp.co.melco.preserv.psvPoint;
import jp.co.melco.preserv.psvRegionBounds;
import java.awt.*;

public class Ev_LineCursor extends Ev_Default_Mouse
{
	private psvPoint _p;     

        private psvPoint sp,ep;
        private Ac_Mouse_IF _ac;
        private Mg_Information_IF _info;
        private Component _canvas;
        private psvJavaScreen _screen;

        int flg=0;

  /**
   * \J[\\CxgIuWFNg\z܂B
   * <p>
   * <p>
   * @since
   * @return
   */
       public Ev_LineCursor()
       { 
       }

  /**
   * \J[\\CxgIuWFNg\z܂B
   * <p>
   * @param    Ac_Mouse_IF  ANVNX
   * <p>
   * @since
   * @return
   */
       public Ev_LineCursor(Ac_Mouse_IF ac)
       { 
           _ac = ac;
           _info = _ac.getInformation();
           _screen = _info.get_screen();
           _canvas = _info.get_canvas();
       }

  /**
   * ANVNXݒB
   * <p>
   * @param    Ac_Mouse_IF  ANVNX
   * <p>
   * @since
   * @return
   */
       public void setAction(Ac_Mouse_IF ac)
       { 
           _ac = ac;
           _info = _ac.getInformation();
           _screen = _info.get_screen();
           _canvas = _info.get_canvas();
       }

  /**
   * \J[\\B
   * <p>
   * @param    MouseEvent  }EXCxg
   * <p>
   * @since
   * @return
   */
       public synchronized void mouseExited(MouseEvent e)
       {
           if(_p != null){

           _screen.set_offscreen_mode(false);
           _screen.set_raster(_screen.GXxor,true);

           _screen.set_color(Color.white);

           _screen.line(sp.x,_p.y,ep.x,_p.y);
           _screen.line(_p.x,sp.y,_p.x,ep.y);

           _screen.set_raster (_screen.GXcopy,true);
           _screen.set_offscreen_mode (true);

           }
           _ac.mouseExited(this);
       }


  /**
   * \J[\\B
   * <p>
   * @param    MouseEvent  }EXCxg
   * <p>
   * @since
   * @return
   */
       public synchronized void mouseMoved(MouseEvent e)
       {
           psvRegionBounds rb = _screen.get_view();

           _screen.expose(_canvas.getGraphics());

           _screen.set_offscreen_mode(false);

           _screen.set_color(Color.black);
           _screen.set_arrow_style(0);
           _screen.set_line_type(0);
           _screen.set_line_width(1);
           _p = _screen.dc_to_wc(e.getX(),e.getY());

           sp = new psvPoint(rb.sx,rb.sy);
           ep = new psvPoint(rb.ex,rb.ey);

           _screen.line(sp.x,_p.y,ep.x,_p.y);
           _screen.line(_p.x,sp.y,_p.x,ep.y);

           _screen.set_offscreen_mode (true);
  
           _ac.mouseMoved(this);
       }


  /**
   * CxgŎ擾SWԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint[]@W
   */
       public psvPoint[] getAllPoint()
       {
            psvPoint[] p = {_p};
            return p;
       }

  /**
   * CxgōŏɎ擾WԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint@W
   */
       public psvPoint getFirstPoint()
       {
             return _p;
       }

  /**
   * CxgōŌɎ擾WԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint@W
   */
       public psvPoint getLastPoint()
       {
             return _p;
       }

  /**
   * CxgŎ擾W
   *`̗̈Ԃ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvRegionBounds@`̗̈
   */
       public psvRegionBounds getRegionBounds()
       {
            return new psvRegionBounds(_p.x,_p.y,_p.x,_p.y);
       }

  /**
   * CxgŎ擾NA܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    
   */
       public void clear()
       {
            _p = null;
       }

  /**
   * I
   * <p>
   * <p>
   * @since
   * @return
   */
    public void close(){}


}
