
package jp.co.melco.preserv.misc;

/*
  ʐρE\_CAO

  ʐρEv\p_CAONXłB

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B

  copyright(c) MITSUBISHI ELECTRIC CORPORATION

*/
import java.awt.*;
import java.util.*;
import java.awt.event.ActionEvent;

import jp.co.melco.preserv.*;

/**
 * ʐρEv\p_CAOB
 */
public class Pr_AreaDialog extends Dialog {
    Panel panel1 = new Panel();
    Button button1 = new Button();
    Button button2 = new Button();
    Button button3 = new Button();
    Pr_AreaDialog ss ;
    String		_title;
    Font		titleFont;
    Color		cellColor;
    Color		inputColor;
    int			cellWidth = 100;
    int			cellHeight = 20;
    int			titleHeight = 20;
    int			rowLabelWidth = 0;
    Font		inputFont;
    boolean		isStopped = false;
    boolean		fullUpdate = true;
    int			rows;
    int			columns;
    int			currentKey = -1;
    int			selectedRow = -1;
    int			selectedColumn = -1;
    Vector distance = new Vector();
    Cell		cells[][];
    Cell		current = null;
    String _result;
    String _resultvalue;

    Mg_Information_IF _info;
    Ev_Mouse_IF _mouse;
    psvJavaScreen _screen;
    Component _canvas;
    public psvPoint[] _p;
    public psvPoint[] _mp;
    String _ShapeKind = "";

    public static Dialog me;

    public Pr_AreaDialog(Frame frame, String title, String text,String shapekind,boolean modal) {
        super(frame, title, modal);

        if(me != null)
          me.dispose();

        me = this;

        Toolkit tk = this.getToolkit();
        Dimension screenSize = tk.getScreenSize();
        setSize(200,210);
        setLocation(screenSize.width/2, screenSize.height/2);
      	rows = 5;
	      columns = 2;
        try  {
            Init();
            if(text != "")
              _result = text;
            else
              _result = "";

            _ShapeKind = shapekind;

            pack();
        }
        catch (Exception ex) {
            ex.printStackTrace();
        }

        	String rs;

	cellColor = Color.white;
	inputColor = new Color(100, 100, 225);
	inputFont = new Font("Courier", Font.PLAIN, 10);
	titleFont = new Font("Courier", Font.BOLD, 12);
        _title = title;

        setCell();

	Dimension d = getSize();
	setSize(columns * cellWidth + rowLabelWidth,
	       (rows + 3) * cellHeight + titleHeight);
    }

    
    public void setCell(){
    	cells = new Cell[rows][columns];

	char l[] = new char[1];
	for (int i=0; i < rows; i++) {
	    for (int j=0; j < columns; j++) {

		cells[i][j] = new Cell(this,
				       Color.lightGray,
				       Color.black,
				       cellColor,
				       cellWidth - 2,
				       cellHeight - 2);
            }
        }
    }
 
    public synchronized void paint(Graphics g) {
	int i, j;
	int cx, cy;
	char l[] = new char[1];


	Dimension d = getSize();

	g.setFont(titleFont);
	i = g.getFontMetrics().stringWidth(_title);
	g.setColor(inputColor);
	g.fillRect(0, cellHeight, d.width, cellHeight);
	g.setColor(Color.white);
	g.drawString((_title == null) ? "v" : _title,
		     25, 15);
 	g.setFont(titleFont);


	for (i=0; i < rows; i++) {
    for (j=0; j < columns; j++) {
		  cx = (j * cellWidth) + 2 + rowLabelWidth;
		  cy = ((i+1) * cellHeight) + 2 + titleHeight;
		  if (cells[i][j] != null) {
		    cells[i][j].paint(g,cx, cy);
		  }
    }
	}

	for (i=0; i < rows+1; i++) {
	    cy = (i+2) * cellHeight;
	    g.setColor(getBackground());
	    g.draw3DRect(0, cy, d.width, 2, true);
	    if (i < rows) {
        if(i+1<rows){
          int kukan = i + 1;
      		g.setColor(Color.blue);
	    	  g.drawString(""+kukan+"",25, cy + 15);
          if(!distance.isEmpty() && distance.size() > i)
	    	    g.drawString((String)distance.elementAt(i),120, cy + 15);
        }else{
       		g.setColor(Color.red);
          g.drawString(_result,35, cy + 15);
          if(Result == this.OK){
            g.drawString(_resultvalue,115, cy + 15);
            Result = END;
          }
        }
	    }
	}
	g.setColor(getBackground());
	g.draw3DRect(0, titleHeight,
		      d.width,
		      d.height - titleHeight,
		      false);
 }

 public void setinit(){
     distance = new Vector();
     _resultvalue = "";
     rows = 5;
     this.setSize(200,210);
     button2.setBounds(new Rectangle(115, cellHeight*rows+50, 65, 30));
     this.repaint();
     _p = null;_mp= null;
     Result = CANCEL;
 }

 public void setInformation(Mg_Information_IF info){ 
     _info = info;
     _canvas = _info.get_canvas();
     _screen = _info.get_screen();
 }

 public void setStartValue(Ev_Mouse_IF mouse){
     _p = new psvPoint[0];
     _mouse = mouse;
 }

public void MiddleResult(psvPoint[] p){
    _p = p;
}

 public void setValue(String dis){
    if(this.Result == END)
        setinit();

    distance.addElement(dis);

    if(distance.size() > 4){
      button2.setBounds(new Rectangle(115, cellHeight*(rows+1)+50, 65, 30));
      Dimension d = this.getSize();
      this.setSize(d.width,d.height + cellHeight);
      rows += 1;
    }

    setCell();
    this.paint(this.getGraphics());
 }

 public void setResult(String area){
    _resultvalue = area;
 }

 public void drawShape(){
        _screen.set_offscreen_mode (false);          
        _screen.set_raster (psvJavaScreen.GXxor,true);      
        _screen.set_color (Color.green);

        if(_p[0] != null){
          _screen.polyline (_mp);                             
        }

        _screen.set_raster (psvJavaScreen.GXcopy,true);     
        if(_ShapeKind == "POLYGON"){
          _screen.set_paint_type(2);
          _screen.polygon(_p);
          _screen.set_paint_type(0);
        }else{
          _screen.polyline(_p);
        }
        _screen.set_offscreen_mode (true);         
 }


    public Pr_AreaDialog() {
        this(new Frame(), "", "","",true);
    }

    void Init() throws Exception {

        /************************************
         * ʒ`
         ************************************/

        this.setLayout(null);

        button2.setLabel("LZ");
        button2.addActionListener(new java.awt.event.ActionListener() {
           public void actionPerformed(ActionEvent e) {
                button2_actionPerformed(e);
           }
        });
        add(button2);
        button2.setBounds(new Rectangle(115, cellHeight*rows+50, 65, 30));
    }

    public static int OK = 1;
    public static int CANCEL = -1;
    public static int END = 2;
    int Result=CANCEL;

    public void Calculation(){
      if(Result == CANCEL){
        Result = OK;
        drawShape();
        this.paint(this.getGraphics());
      }
    }

    void button1_actionPerformed(ActionEvent e) {
      if(Result == CANCEL){
        Result = OK;
        drawShape();
        this.paint(this.getGraphics());

      }
    }

    void button2_actionPerformed(ActionEvent e) {
        this.setVisible(false);
        _screen.view(_screen.get_view());
        _canvas.repaint();
        _mouse.clear();
        setinit();
        Result = END;
    }

    public void setMoveP(psvPoint[] p){
       _mp = p;
    }

    public int getAction(){
        return Result;
    }

    int cnt = 1;

    public void setLabelText(String text){
    }

    public void clear(){
    }

    public void dispose() {
       me = null;
       super.dispose();
    }




}
    class Cell {
    public static final int VALUE = 0;
    public static final int LABEL = 1;
    public static final int URL   = 2;
    public static final int FORMULA = 3;

    boolean	needRedisplay;
    boolean selected = false;
    boolean transientValue = false;
    public int	type = Cell.VALUE;
    String	valueString = "";
    String	printString = "v";
    float	value;
    Color	bgColor;
    Color	fgColor;
    Color	highlightColor;
    int		width;
    int		height;
    Pr_AreaDialog app;
    boolean	paused = false;

    public Cell(Pr_AreaDialog app,
		Color bgColor,
		Color fgColor,
		Color highlightColor,
		int width,
		int height) {
	this.app = app;
	this.bgColor = bgColor;
	this.fgColor = fgColor;
	this.highlightColor = highlightColor;
	this.width = width;
	this.height = height;
	needRedisplay = true;
    }



    public void paint(Graphics g,int x, int y) {

	    g.setColor(bgColor);
	    g.fillRect(x, y, width - 1, height);
    }


 }

