package jp.co.melco.preserv.misc ;

/*
  [y_CAO

  [y_CAONXłB

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B

  copyright(c) MITSUBISHI ELECTRIC CORPORATION

*/

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import jp.co.melco.preserv.*;


public class Pr_LoupeDialog extends  Dialog  implements ComponentListener, MouseListener, MouseMotionListener  {

    private psvJavaScreen  m_screen ;
    private psvJCanvas     m_canvas;
    private Component    _canvas ;
    private psvJavaScreen  _screen ;
    public psvPoint motion_s ;
    public psvPoint motion_e ;


    private psvRegionBounds m_old_region ;

    /**  */
    public static Pr_LoupeDialog m_dialog ;

    public static Dialog me;

    public Pr_LoupeDialog(Frame parent, Mg_Information_IF info)
    {
	super(parent, "[y") ;

        if(me != null){
          me.dispose();
          eraseRect();
        }

        me = this;
	
        _canvas = info.get_canvas();
        _screen = info.get_screen();

	setSize(210,270) ;
	GridBagConstraints gc = new GridBagConstraints() ;
	GridBagLayout gl = new GridBagLayout() ;
	setLayout(gl) ;
	
	Button  btn = null ;
        m_canvas = new psvJCanvas();
	m_canvas.setSize(200, 190) ;
	add(m_canvas) ;

	m_canvas.addMouseListener(this) ;
	m_canvas.addMouseMotionListener(this) ;
	m_canvas.setBackground(Color.white) ;

	gc.gridwidth = GridBagConstraints.REMAINDER ;
	gc.gridheight = 1 ;
	gc.fill = GridBagConstraints.HORIZONTAL ;
	gc.insets = new Insets(10, 5, 5, 5) ;
	gl.setConstraints(m_canvas,gc) ;

	btn = new Button("g") ;
	btn.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent ev){
		int scale = m_screen.get_scale();
		if (scale >= 75) {
		psvRegionBounds rb = m_screen.get_view() ;
		m_screen.view(rb.sx + 5, rb.sy + 5,
			      rb.ex - 5, rb.ey - 5) ;
		m_canvas.repaint() ;
		drawRect() ;
		}
	    }
	}) ;
	add(btn) ;

	gc.gridwidth = GridBagConstraints.RELATIVE;
	gc.gridheight = 1 ;
	gc.fill = GridBagConstraints.BOTH ;
	gc.weightx = 20.0;
	gc.insets = new Insets(0, 10, 5, 0) ;
	gl.setConstraints(btn,gc) ;

	btn = new Button("k") ;
	btn.addActionListener(new ActionListener(){
	    public void actionPerformed(ActionEvent ev){
		psvRegionBounds rb = m_screen.get_view() ;
		m_screen.view(rb.sx - 5, rb.sy - 5,
			      rb.ex + 5, rb.ey + 5) ;
		m_canvas.repaint() ;
		drawRect() ;
	    }
	}) ;
	add(btn) ;


	gc.gridwidth = GridBagConstraints.REMAINDER ;
	gc.gridheight = 1 ;
	gc.fill = GridBagConstraints.HORIZONTAL ;
	gc.insets = new Insets(0, 10, 5, 10) ;
	gl.setConstraints(btn,gc) ;

	setResizable(false); 

	addComponentListener(this) ;
    }

    private void submitDialog()
    {
	setVisible(false) ;
    }

    public void showDialog(psvPoint pp)
    {
	setVisible(true) ;
        Vector vmap = _screen.getAllMap();
	if(m_screen == null){
	    m_screen = new psvJavaScreen(m_canvas, 0f, 0f, 100f, 100f) ;
            for(int i=0;i<vmap.size();i++)
	       m_screen.addMap((psvAnyMap)vmap.elementAt(i)) ;

	}
	/*[yg̑傫*/
	int of_value = 10;
	m_screen.view(new psvRegionBounds(pp.x - of_value, pp.y - of_value ,
					  pp.x + of_value, pp.y + of_value)) ;
	drawRect() ;
    }

    public void change_view(psvPoint pp)
    {
	psvRegionBounds rb = m_screen.get_view() ;

	float w = (rb.ex - rb.sx)/2.0f ;
	float h = (rb.ey - rb.sy)/2.0f ;

	rb = new psvRegionBounds(pp.x - w, pp.y - h, pp.x + w, pp.y + h) ;

	m_screen.set_offscreen_mode(true) ;
	m_screen.view(rb) ;

	m_screen.expose(m_canvas.getGraphics());
	m_screen.set_offscreen_mode(false) ;

	drawRect() ;
    }
    
    /** R|[lgTCYꂽƂɌĂяo܂B */
    public void componentResized(ComponentEvent e){ }

    
    /** R|[lgړꂽƂɌĂяo܂B */
    public void componentMoved(ComponentEvent e)
    { 
	Point po = getLocation() ;

    }

    /** R|[lg\ꂽƂɌĂяo܂B */
    public void componentShown(ComponentEvent e){ }


    public void componentHidden(ComponentEvent e){ }


    public void drawRect()
    {
		float of_value = 10;

		if(m_old_region != null){
                   repair_canvas(m_old_region.sx - of_value, 
					   m_old_region.sy - of_value,
					   m_old_region.ex + of_value,
					   m_old_region.ey + of_value,
					   _screen,
					   _canvas) ;
		}

		_screen.set_offscreen_mode(false) ;
	        _screen.set_paint_type(0); 
		_screen.set_color(new psvColor(Color.red, Color.red)) ;
		psvRegionBounds rb = m_screen.get_view() ;
		_screen.rectangle(rb.sx , rb.sy, rb.ex, rb.ey) ; /*[yg*/
		_screen.set_offscreen_mode(true) ;

		m_old_region = rb ;
	}

    public void eraseRect()
    {
		float of_value = 2;

		if(m_old_region != null){

		    repair_canvas(m_old_region.sx - of_value, 
					   m_old_region.sy - of_value,
					   m_old_region.ex + of_value,
					   m_old_region.ey + of_value,
					   _screen,
					   _canvas) ;
		}
	}

	public void mouseDragged(MouseEvent ev)
	{
		int x = ev.getX();
		int y = ev.getY();
		// XN[
		motion_e = m_screen.dc_to_wc(x, y);
		m_screen.set_offscreen_mode(true);
		psvRegionBounds rb = m_screen.get_view() ;
		m_screen.view(rb);
		m_screen.translate(motion_s.x - motion_e.x,motion_s.y - motion_e.y, true) ;
		drawRect() ;
	}


	public void mouseMoved(MouseEvent ev)
	{
	}


	public void mouseClicked(MouseEvent ev)
	{
	int x = ev.getX();
	int y = ev.getY();
	//XN[
	motion_s = m_screen.dc_to_wc(x, y);
	}


	public void mouseEntered(MouseEvent ev)
	{
	}


	public void mouseExited(MouseEvent ev)
	{
	}


	public void mouseReleased(MouseEvent ev)
	{
	m_screen.set_offscreen_mode(false);
	}


	public void mousePressed(MouseEvent ev)
	{
		int x = ev.getX();
		int y = ev.getY();
		//XN[
		motion_s = m_screen.dc_to_wc(x, y);
	}

    /**
       w͈͂𕔕ĕ`悷
       @param sx   XW
       @param sy   YW
       @param ex   EXW
       @param ey   EYW
       @param screen 
       @param canvas 
    */
     public void repair_canvas(float sx, float sy, float ex, float ey,
				     psvJavaScreen screen,  Component canvas)
    {
	screen.set_offscreen_mode(true) ;
	Graphics gr = canvas.getGraphics() ;

	Point p1 = screen.wc_to_dc(sx, ey) ;
	Point p2 = screen.wc_to_dc(ex, sy) ;
	
	gr.setClip(p1.x, p1.y, (p2.x - p1.x), (p2.y - p1.y)) ;
	
	canvas.paint(gr) ;

	gr.dispose() ;
	
	gr = null ;
    }

    /**
       ŵQIuWFNg߂͈͂𕔕ĕ`悷
       @param any    QIuWFNg
       @param screen
       @param canvas
    */
    public void repair_canvas(psvShape any, psvJavaScreen screen,  Component canvas)
    {
	repair_canvas(any.sx(), any.sy(), any.ex(), any.ey(), screen, canvas) ;
    }

}

