package jp.co.melco.preserv.misc;

/*
  Perspective_CAO

  Perspective_CAONXłB

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B

  copyright(c) MITSUBISHI ELECTRIC CORPORATION

*/

import java.awt.Component;
import java.awt.Dialog;
import java.awt.Button;
import java.awt.TextField;
import java.awt.Checkbox;
import java.awt.Choice;
import java.awt.Frame;
import java.awt.Toolkit;
import java.awt.Dimension;
import java.awt.Panel;
import java.awt.Color;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyListener;
import java.awt.event.KeyEvent;

import jp.co.melco.preserv.psvJavaScreen;
import jp.co.melco.preserv.psvJCanvas;
import jp.co.melco.preserv.psvDrawContext;
import jp.co.melco.preserv.psvContext;
import jp.co.melco.preserv.psvColor;
import jp.co.melco.preserv.psvPoint;
import jp.co.melco.preserv.psvAttrib;
import jp.co.melco.preserv.psvTextContext;
import jp.co.melco.preserv.psvFontData;
import jp.co.melco.preserv.psvRegionBounds;

/**
 * Perspective_CAOB
 */
public class Pr_PerspectiveDialog extends Dialog implements ActionListener,KeyListener{
    private Button	okButton;
    private Button	ngButton;
    private TextField z_text,height_text;
    private TextField text_r,text_g,text_b;
    private Label color_label;
    private Checkbox check;
    private Choice choice1;
    private psvJavaScreen _screen;
    private Component _canvas;

    public static int OK = 1;
    public static int CANCEL = -1;
    int Result=CANCEL;



  /**
   * Perspective_CAO\z܂B
   * <p>
   * @param    frame     _CAȌL
   * @param    title     _CAÕ^Cg
   * @param    context   }`IuWFNg
   * @param    modal     [_
   * <p>
   * @since
   * @return
   */
    public Pr_PerspectiveDialog(Frame frame,String title,Component canvas,psvJavaScreen screen,boolean modal)
    {
	super(frame,title,modal) ;

        _screen = screen;
        _canvas = canvas;

  Toolkit tk = this.getToolkit();
  Dimension screenSize = tk.getScreenSize();
  setLocation(screenSize.width/2, screenSize.height/2); 

  String z_point = "750";
  String hrheight = "200";
  String degree = "0";
  int color_r = 0;
  int color_g = 0;
  int color_b = 0;

    hrheight = new Integer(_screen.get_hrheight()).toString();
    z_point = new Double(_screen.get_depth()).toString();
    Color scol = _screen.get_skycolor().line_color;
    color_r = scol.getRed();
    color_g = scol.getGreen();
    color_b = scol.getBlue();

  setSize(200, 230);
  this.setLayout(null);

  Panel panel1 = new Panel();
  panel1.setSize(200,20);
  panel1.setLocation(0,30);
  panel1.setBackground(Color.gray);
  panel1.setLayout(null) ;

  Label label1 = new Label("px");
  label1.setLocation(10,0);
  label1.setSize(50,20);
  label1.setForeground(Color.white);

  choice1  = new Choice();
  choice1.addItem("O");
  choice1.addItem("PO");
  choice1.addItem("QO");
  choice1.addItem("RO");
  choice1.addItem("SO");
  choice1.addItem("TO");
  choice1.addItem("UO");
  choice1.addItem("VO");
  choice1.addItem("WO");
  choice1.setLocation(70,0);
  choice1.setSize(120,15);
  panel1.add (label1);
  panel1.add (choice1);

  Panel panel2 = new Panel();
  panel2.setSize(200,20);
  panel2.setLocation(0,60);
  panel2.setBackground(Color.gray);
  panel2.setLayout(null) ;

  z_text = new TextField(z_point,3);

  Label label2 = new Label("s");
  label2.setLocation(10,0);
  label2.setSize(50,20);
  label2.setForeground(Color.white);
  z_text.setLocation(70,2);
  z_text.setSize(120,15);
  z_text.setBackground(Color.white);
  panel2.add (label2);
  panel2.add (z_text);

  Panel panel3 = new Panel();
  panel3.setSize(200,20);
  panel3.setLocation(0,90);
  panel3.setBackground(Color.gray);
  panel3.setLayout(null) ;

  height_text = new TextField(hrheight,3);

  Label label3 = new Label("n");
  label3.setLocation(10,0);
  label3.setSize(50,20);
  label3.setForeground(Color.white);
  height_text.setLocation(70,2);
  height_text.setSize(120,15);
  height_text.setBackground(Color.white);
  panel3.add (label3);
  panel3.add (height_text);

  Panel panel4 = new Panel();
  panel4.setSize(200,20);
  panel4.setLocation(0,120);
  panel4.setBackground(Color.gray);
  panel4.setLayout(null) ;

  text_r = new TextField(String.valueOf(color_r),10);
  Label label4 = new Label("Fw");
  label4.setLocation(10,0);
  label4.setSize(40,20);
  label4.setForeground(Color.white);
  color_label = new Label();
  color_label.setLocation(55,0);
  color_label.setSize(10,20);
  color_label.setBackground(Color.white);
  text_r.setLocation(70,0);
  text_r.setSize(30,20);
  text_r.setBackground(Color.red);
  text_r.addKeyListener(this);
  panel4.add(label4);
  panel4.add(color_label);
  panel4.add(text_r);

  text_g = new TextField(String.valueOf(color_g),10);
  text_g.setLocation(110,0);
  text_g.setSize(30,20);
  text_g.setBackground(Color.green);
  text_g.addKeyListener(this);
  panel4.add(text_g);

  text_b = new TextField(String.valueOf(color_b),10);
  text_b.setLocation(150,0);
  text_b.setSize(30,20);
  text_b.setBackground(new Color(0,80,200));
  text_b.addKeyListener(this);
  panel4.add(text_b);

  view_color();

  Panel btn_panel = new Panel();
  btn_panel.setSize(200,50);
  btn_panel.setLocation(0,150);
  btn_panel.setLayout(null) ;


  okButton = new Button("OK");

  okButton.addActionListener(this);
  okButton.setLocation(30,5);
  okButton.setSize(50,30);
	ngButton = new Button("LZ");
  ngButton.setLocation(85,5);
  ngButton.setSize(80,30);
  ngButton.addActionListener(this);


  btn_panel.add(okButton) ;
  btn_panel.add(ngButton) ;

  add(panel1);
  add(panel2);
  add(panel3);
  add(panel4);
  add(btn_panel);

    }

  public void actionPerformed(ActionEvent e){
      String command = e.getActionCommand();

      if(command == "OK"){

          if(!CheckTextValue(z_text,0))return;
          if(!CheckTextValue(height_text,1))return;

          int index = choice1.getSelectedIndex();
          int degree = 0;
          switch (index){
          case 0:
              degree = 0;
              break;
          case 1:
              degree = 100;
              break;
          case 2:
              degree = 200;
              break;
          case 3:
              degree = 300;
              break;
          case 4:
              degree = 400;
              break;
          case 5:
              degree = 500;
              break;
          case 6:
              degree = 600;
              break;
          case 7:
              degree = 700;
              break;
          case 8:
              degree = 800;
              break;
          }



          double z_point = new Double(z_text.getText()).doubleValue();
          int height = Integer.parseInt(height_text.getText());

          int color_r = 0;
          if(CheckColorValue(text_r))
            color_r = Integer.parseInt(text_r.getText());
          else
            return;
          int color_g = 0;
          if(CheckColorValue(text_g))
            color_g = Integer.parseInt(text_g.getText());
          else
            return;
          int color_b = 0;
          if(CheckColorValue(text_b))
            color_b = Integer.parseInt(text_b.getText());
          else
            return;

          psvColor color = new psvColor(new Color(color_r,color_g,color_b));

          float sy = _screen.get_view().sy;

          //ݒ
          psvPoint center = getCenter(_screen.get_view());
          _screen.perspective(center.x,sy,degree);
          _screen.set_skycolor(color);
          _screen.set_depth(z_point);
          _screen.set_hrheight(height,true);

          _screen.view(_screen.get_view());
          _canvas.repaint();

          Result = OK;
          this.setVisible(false);
      }else{
        Result = CANCEL;
        this.setVisible(false);
      }

  }

  //_
  private psvPoint getCenter(psvRegionBounds rb){
      float _sx = Math.min( rb.sx, rb.ex ) ;
      float _sy = Math.min( rb.sy, rb.ey ) ;
      float _ex = Math.max( rb.sx, rb.ex ) ;
      float _ey = Math.max( rb.sy, rb.ey ) ;
      float _cx = (_ex - _sx)/2 + _sx ;
      float _cy = (_ey - _sy)/2 + _sy ;
      return new psvPoint(_cx,_cy);
  }



  private boolean CheckColorValue(TextField text) {
        boolean rangeError = false;
        int i_value = 0;
        try{
           i_value = Integer.parseInt(text.getText());
        }catch(NumberFormatException e){
           text.setText("0");
           text.requestFocus();
           return false;
        }

	      if ( i_value < 0 || i_value > 255) {
           text.setText("0");
           text.requestFocus();
           return false;
	      }
        return true;
  }

  private boolean CheckTextValue(TextField text,int mode) {
        boolean rangeError = false;
        String s_value = "";
        int i_value = 0;
        double d_value = 0f;
        if(mode == 0){
          try{
           d_value = new Double(text.getText()).doubleValue();
          }catch(Exception e){
           text.setText("750");
           text.requestFocus();
           return false;
          }
        }else if(mode == 2){
          try{
           i_value = Integer.parseInt(text.getText());
          }catch(Exception e){
           text.setText("200");
           text.requestFocus();
           return false;
          }
        }
        return true;
  }

  public void keyPressed(KeyEvent e){
  }
 
  public void keyReleased(KeyEvent e){
  }

  public void keyTyped(KeyEvent e){
      view_color();
  }

  private void view_color(){
      int color_r = 0;
      if(CheckColorValue(text_r))
        color_r = Integer.parseInt(text_r.getText());
      else
        return;
      int color_g = 0;
      if(CheckColorValue(text_g))
         color_g = Integer.parseInt(text_g.getText());
      else
         return;
      int color_b = 0;
      if(CheckColorValue(text_b))
         color_b = Integer.parseInt(text_b.getText());
      else
         return;

      color_label.setBackground(new Color(color_r,color_g,color_b));

  }
           
  /**
   * ANV[h擾B
   * <p>
   * @param
   * <p>
   * @since
   * @return   int s/LZ
   */
  public int getResult(){
       return Result;
  }



}




