package jp.co.melco.preserv.misc;

/*

  Y[ANV

  Y[CxgɑΉNXłB


  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B

  copyright(c) MITSUBISHI ELECTRIC CORPORATION

*/

import jp.co.melco.preserv.*;

import java.awt.*;



/**
 * Y[ANVB
 */
public class Ac_Zoom extends Ac_Default_Mouse
{

    Point _p;
    Image    _img ;
    Rectangle  _old_rect = new Rectangle(0, 0, 1, 1) ;

    Mg_Information_IF _info;
    psvJavaScreen _screen;
    Component _canvas;


  /**
   * Y[ANVIuWFNg\z܂B
   * <p>
   * <p>
   * @since
   * @return
   */
    public  Ac_Zoom()
    {
    }

  /**
   * Y[ANVIuWFNg\z܂B
   * <p>
   * @param    Mg_Information_IF ǗNX
   * <p>
   * @since
   * @return
   */
    public  Ac_Zoom(Mg_Information_IF info)
    {
	_info = info;
        _screen = _info.get_screen();
        _canvas = _info.get_canvas();
    }

  /**
   * ǗNXݒB
   * <p>
   * @param    Mg_Information_IF  ǗNX
   * <p>
   * @since
   * @return
   */
    public  void setInformation(Mg_Information_IF info)
    {
	_info = info;
        _screen = _info.get_screen();
        _canvas = _info.get_canvas();
    }


  /**
   * Y[JnANVB
   * <p>
   * @param    Ev_Mouse_IF  CxgNXIuWFNg
   * <p>
   * @since
   * @return
   */
    public void mousePressed(Ev_Mouse_IF ev)
    {
        psvPoint p  = ev.getFirstPoint();
        _p = _screen.wc_to_dc(p.x,p.y);
	_img = ((psvComponent)_canvas).getImage() ;
    }

  /**
   * Y[IANVB
   * <p>
   * @param    Ev_Mouse_IF  CxgNXIuWFNg
   * <p>
   * @since
   * @return
   */
    public void mouseReleased(Ev_Mouse_IF ev)
    {
        psvPoint p  = ev.getLastPoint();
  	Point p2 = _screen.wc_to_dc(p.x,p.y);

        int ratio = ratio = new Float(Math.abs(_p.x - p2.x)).intValue();

 	Dimension d = _canvas.getSize() ;

        psvPoint sp = _screen.dc_to_wc(ratio, ratio) ;
        psvPoint ep = _screen.dc_to_wc(d.width-ratio, d.height-ratio) ;

        psvRegionBounds rb = new psvRegionBounds(sp.x,sp.y,ep.x,ep.y);
        if(p2.x > _p.x){
           _screen.view(rb) ;
        } else {
    	   _screen.shrink(rb) ;
	}
      	_canvas.repaint() ;

        _p = null;
        _img = null ;
    }

  /**
   * Y[ANVB
   * <p>
   * @param    Ev_Mouse_IF  CxgNXIuWFNg
   * <p>
   * @since
   * @return
   */
    public void mouseDragged(Ev_Mouse_IF ev)
    {

	    int ratio = 1 ;
            psvPoint p  = ev.getLastPoint();
            Point p2 = _screen.wc_to_dc(p.x,p.y);
	    ratio = new Float(Math.abs(_p.x - p2.x)).intValue();
	
	    _screen.set_offscreen_mode(true) ;
	    Graphics gr = _canvas.getGraphics() ;

	    Dimension d = _canvas.getSize() ;
	    int ratio_y = ratio * d.height / d.width;

            if(p2.x > _p.x){
	       gr.drawImage(_img,0, 0, d.width, d.height,
			 ratio, ratio_y, d.width-ratio, d.height-ratio_y, 
			 _canvas) ;
	    } 
else {
               Rectangle rect = new Rectangle(ratio, ratio_y,(d.width-ratio - ratio),(d.height-ratio_y-ratio_y)) ;
 	       gr.clearRect(_old_rect.x, _old_rect.y,  _old_rect.width,  _old_rect.height);
	       gr.drawImage(_img, ratio, ratio_y, d.width-ratio, d.height-ratio_y, 
			 0, 0, d.width, d.height,_canvas) ;
               _old_rect = rect ;
	   }

           gr.dispose() ;
	
	   gr = null ;
    }

  /**
   * I
   * <p>
   * <p>
   * @since
   * @return
   */
    public void close(){}


  /**
   * ǗNXԂ܂
   * <p>
   * <p>
   * @since
   * @return   Mg_Information_IF ǗNX
   */
    public Mg_Information_IF getInformation(){return _info;}


}

