package jp.co.melco.preserv.misc;

/*
  |C`Cxg

  }EXENbNŐ̎n_EI_𕡐w肵A|C`悵܂B

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B

  copyright(c) MITSUBISHI ELECTRIC CORPORATION

*/

import java.awt.Color ;
import java.awt.event.MouseEvent ;
import java.util.Vector;

import jp.co.melco.preserv.psvDrawContext;
import jp.co.melco.preserv.psvPoint;
import jp.co.melco.preserv.psvJavaScreen;
import jp.co.melco.preserv.psvShape;
import jp.co.melco.preserv.psvColor;
import jp.co.melco.preserv.psvAnyData;
import jp.co.melco.preserv.psvAttrib;
import jp.co.melco.preserv.psvPolylineData;
import jp.co.melco.preserv.psvRegionBounds;

/**
 *|C`CxgB
 */
public class Ev_Rubber_Polyline extends Ev_Default_Mouse
{
    private Ac_Mouse_IF _ac ;
    private psvJavaScreen _screen;
    private psvPoint _p;
    private psvPoint[] _pp = new psvPoint[2];
    private psvPoint[] p;
    private Vector _vp = new Vector();

  /**
   * |C`CxgIuWFNg\z܂B
   * <p>
   * @param    
   * <p>
   * @since
   * @return
   */
    public Ev_Rubber_Polyline()
    {
    }


  /**
   * |C`CxgIuWFNg\z܂B
   * <p>
   * @param    Ac_Mouse_IF  ANVCxg
   * <p>
   * @since
   * @return
   */
    public Ev_Rubber_Polyline(Ac_Mouse_IF ac)
    {
	    _ac = ac ;
            Mg_Information_IF info = _ac.getInformation();
            _screen = info.get_screen();
    }

  /**
   * ANVNXݒ肵܂B
   * <p>
   * @param    Ac_Mouse_IF  ANVNX
   * <p>
   * @since
   * @return
   */
    public void setAction(Ac_Mouse_IF ac)
    {
	    _ac = ac ;
            Mg_Information_IF info = _ac.getInformation();
            _screen = info.get_screen();
    }


  /**
   * }EXEvXCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mousePressed(MouseEvent e)
    {
         _p = _screen.dc_to_wc (e.getX(),e.getY());       
         _vp.addElement (_p);                          
         p = new psvPoint[_vp.size()];    
         for(int i=0;i<_vp.size ();i++)
            p[i] = new psvPoint((psvPoint)_vp.elementAt (i));

         if(e.getClickCount() == 1){                 
            _screen.set_offscreen_mode (false);
            _screen.set_color (Color.black);
            _screen.polyline (p);
            _screen.set_offscreen_mode (true);
         }else{                                      
            psvDrawContext dc = new psvDrawContext();
            dc.attrib(psvAttrib.VISIBLE | psvAttrib.DETECTIVE);
            dc.set_color(new psvColor(Color.black));

            psvShape any = new psvPolylineData(p,dc, null) ;

            _ac.mousePressed(this);

            p = new psvPoint[0];_p=null;_vp=new Vector();
         }
    }

  /**
   * }EXE[uCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mouseMoved(MouseEvent e)
    {
      if(_p != null){           
        _screen.set_offscreen_mode (false);         
        _screen.set_line_type(0);
        _screen.set_line_width(1);
        _screen.set_arrow_style(0);
        _screen.set_raster (_screen.GXxor,true);      
        _screen.set_color(Color.green);

        if(_pp[0] != null){
          _screen.polyline (_pp);                             
        }

        psvPoint mp = _screen.dc_to_wc (e.getX(),e.getY());  
        _pp[0] = new psvPoint(_p);
        _pp[1] = new psvPoint(mp);
        _screen.polyline (_pp);                              
        _screen.set_raster (_screen.GXcopy,true);     
        _screen.set_offscreen_mode (true);           
     }
    }


  /**
   * CxgŎ擾SWԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint[]@W
   */
    public psvPoint[] getAllPoint(){
         return p;
    }

  /**
   * CxgŎ擾WNA܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return
   */
    public void clear(){
       p = new psvPoint[0];_p=null;_vp=new Vector();
    }

  /**
   * CxgōŏɎ擾WԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint@W
   */
    public psvPoint getFirstPoint(){
        return p[0];
    }

  /**
   * CxgōŌɎ擾WԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint@W
   */
    public psvPoint getLastPoint(){
        return p[p.length-1];
    }

  /**
   * CxgŎ擾W
   *`̗̈Ԃ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvRegionBounds@`̗̈
   */
    public psvRegionBounds getRegionBounds(){
        return new psvRegionBounds(p[0].x,p[0].y,p[p.length-1].x,p[p.length-1].y);
    }

  /**
   * I
   * <p>
   * <p>
   * @since
   * @return
   */
    public void close(){}


}

