package jp.co.melco.preserv.misc;

/*
  `o[ohCxg

  }EXENbNăhbMOsƁANbN_
  ƃ}EẌʒuΊpƂ`o[oh\܂B

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B
  
  copyright(c) MITSUBISHI ELECTRIC CORPORATION
  
*/

import java.awt.Color ;
import java.awt.event.MouseEvent ;

import jp.co.melco.preserv.psvJavaScreen ;
import jp.co.melco.preserv.psvPoint ;
import jp.co.melco.preserv.psvRegionBounds ;


/**
 *`o[ohCxgB
 */
public class Ev_Rubber_Rect extends Ev_Default_Mouse
{
    private Ac_Mouse_IF  _ac ;
    private Mg_Information_IF _info;
    private psvJavaScreen _screen;


  /**
   * `o[ohCxgIuWFNg\z܂B
   * <p>
   * <p>
   * @since
   * @return
   */
    public Ev_Rubber_Rect()
    {
    }

  /**
   * `o[ohCxgIuWFNg\z܂B
   * <p>
   * @param    Ac_Mouse_IF  ANVCxg
   * <p>
   * @since
   * @return
   */
    public Ev_Rubber_Rect(Ac_Mouse_IF ac)
    {
	_ac = ac ;
        _info = _ac.getInformation();
        _screen = _info.get_screen();
        
    }

  /**
   * ANVݒB
   * <p>
   * @param    Ac_Mouse_IF  ANVNX
   * <p>
   * @since
   * @return
   */
    public void setAction(Ac_Mouse_IF ac)
    {
	_ac = ac ;
        _info = _ac.getInformation();
        _screen = _info.get_screen();
        
    }

    psvPoint _sp ;
    psvPoint _tp ;


  /**
   * }EXEvXCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mousePressed(MouseEvent e)
    {
  	int x = e.getX();
  	int y = e.getY();

	_sp = _screen.dc_to_wc(x, y) ;
  _screen.set_line_type(0);
  _screen.set_arrow_style(0);
	_screen.set_offscreen_mode(false) ;
	_screen.set_raster(psvJavaScreen.GXxor, true) ;
  _screen.set_line_width(0) ;
  _screen.set_paint_type(0) ;
	_screen.set_color(Color.green) ;
    }

  /**
   * }EXE[XCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mouseReleased(MouseEvent e)
    {
	int x = e.getX();
	int y = e.getY();

	_tp = _screen.dc_to_wc(x, y) ;

	_screen.set_raster(psvJavaScreen.GXcopy, true) ;
	_screen.set_offscreen_mode(true) ;

	if((_sp.x != _tp.x) && (_sp.y != _tp.y)){
	    _ac.mouseReleased(this) ;
	}
	_sp = null ;
	_tp = null ;
    }


  /**
   * }EXEhbOCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mouseDragged(MouseEvent e)
    {
  	int x = e.getX();
  	int y = e.getY();


	if(_tp != null){
	    _screen.rectangle(_sp.x, _sp.y, _tp.x, _tp.y) ;
	}

	_tp = _screen.dc_to_wc(x, y) ;
	_screen.rectangle(_sp.x, _sp.y, _tp.x, _tp.y) ;
    }


  /**
   * CxgŎ擾SWԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint[]@W
   */
    public psvPoint[] getAllPoint(){
        psvPoint[] p = {_sp,_tp};
        return p;
    }

  /**
   * CxgŎ擾WNA܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return
   */
    public void clear(){
        _sp = null;_tp = null;
    }

  /**
   * CxgōŏɎ擾WԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint@W
   */
    public psvRegionBounds getRegionBounds()
    {
	return new psvRegionBounds(_sp.x, _sp.y, _tp.x, _tp.y) ;
    }

  /**
   * CxgōŌɎ擾WԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvPoint@W
   */
    public psvPoint getFirstPoint()
    {
	return _sp ;
    }

  /**
   * CxgŎ擾W
   *`̗̈Ԃ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvRegionBounds@`̗̈
   */
    public psvPoint getLastPoint()
    {
	return _tp ;
    }

  /**
   * I
   * <p>
   * <p>
   * @since
   * @return
   */
    public void close(){}


}

