package jp.co.melco.preserv.misc;
/*
  }`O[vCxgNX

  w肵}`O[v܂B

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B

  copyright(c) MITSUBISHI ELECTRIC CORPORATION

*/
import java.awt.* ;
import java.awt.event.MouseEvent ;
import java.util.Vector;
import java.util.Enumeration;

import jp.co.melco.preserv.*;
import jp.co.melco.preserv.common.mdmBasicValue;

/**
 * }`O[vCxgB
 */
public class Ev_ShapeGrouping extends Ev_Default_Mouse
{
    Mg_Information_IF _info;
    private Ac_Mouse_IF _ac ;
    private Component _canvas;
    private psvJavaScreen _screen;
    private psvPoint _p,_p2 ;
    private psvShape _draw_shape;
    private psvShape _keep;
    private psvGroup _pg;
    private psvMdmMapEx mdm_map;

    private Vector _vec;

  /**
   * }`O[vCxgIuWFNg\z܂B
   * <p>
   * <p>
   * @since
   * @return
   */
    public Ev_ShapeGrouping()
    {
    }

  /**
   * }`O[vCxgIuWFNg\z܂B
   * <p>
   * @param    Ac_Mouse_IF  ANVCxg
   * <p>
   * @since
   * @return
   */
    public Ev_ShapeGrouping(Ac_Mouse_IF ac)
    {
      _ac = ac ;
      _info = _ac.getInformation();
      _canvas = _info.get_canvas();
      _screen = _info.get_screen();
      _pg = creategroup();
      mdm_map = _info.get_map();
      _vec = new Vector();
    }

  /**
   * ANVNXݒB
   * <p>
   * @param    Ac_Mouse_IF  ANVCxg
   * <p>
   * @since
   * @return
   */
    public void setAction(Ac_Mouse_IF ac)
    {
      _ac = ac ;
      _info = _ac.getInformation();
      _canvas = _info.get_canvas();
      _screen = _info.get_screen();
      _pg = creategroup();
      mdm_map = _info.get_map();
      _vec = new Vector();
    }


  /**
   * }EXENbNCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mouseClicked(MouseEvent e)
    {
      if(e.getClickCount() == 2){
        if(_vec.size() == 1){
          _draw_shape = (psvShape)_vec.elementAt(0);
          _vec.removeAllElements();
          _screen.set_offscreen_mode (false);
          _draw_shape.draw(_screen,null, false);
          _screen.set_offscreen_mode (true);
        }
        for (Enumeration _e = _vec.elements() ; _e.hasMoreElements() ;) {
          psvShape _shape = (psvShape)_e.nextElement();
          String group_key = _shape.get_values("group_kind")._value.toString();
          mdm_map.erase_data(group_key,_shape);
          mdm_map.reflect_mdm();
        }
        for (Enumeration _e = _vec.elements() ; _e.hasMoreElements() ;) {
          psvShape _shape = (psvShape)_e.nextElement();
          _pg.insert_data(_shape,0);
        }
        setActionState(true);
        _ac.mouseClicked(this);
        _vec.removeAllElements();
        _pg = creategroup();
      }
    }

  /**
   * }EXEvXCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mousePressed(MouseEvent e)
    {
        if(_draw_shape == null)return;
        if(_vec.contains(_draw_shape)){
          _vec.removeElement(_draw_shape);
          _screen.set_offscreen_mode (false);
          _draw_shape.draw(_screen,null, false);
          _screen.set_offscreen_mode (true);
        }else{
          _vec.addElement(_draw_shape);
          for (Enumeration _e = _vec.elements() ; _e.hasMoreElements() ;) {
            psvShape _shape = (psvShape)_e.nextElement();
            _screen.set_offscreen_mode (false);
            _shape.draw(_screen, new psvColor(Color.blue), false);
            _screen.set_offscreen_mode (true);
            _keep = null;
          }
        }
    }


  /**
   * }EXE[uCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mouseMoved(MouseEvent e)
    {
      try{
        _p = _screen.dc_to_wc (e.getX(),e.getY());
        psvRegionSelect rs = new psvRegionSelect(null,new psvRegion(_p.x-1,_p.y-1,_p.x+1,_p.y+1));
        psvSearch ps = new psvSearch(rs,false);
        if (mdm_map.search(ps)&&ps.getCount() > 0){
          psvShape _any = nearshape(_p,ps.elements(0));
          if(_keep != null){
            _screen.set_offscreen_mode (false);
            _keep.draw(_screen,null);
            _screen.set_offscreen_mode (true);
            _keep = null;
          }
          if(!_vec.contains(_any)){
            _screen.set_offscreen_mode (false);
            _any.draw(_screen, new psvColor(Color.magenta), false);
            _screen.set_offscreen_mode (true);
            _keep = _any;
            _draw_shape = _any;
          }else{
            _draw_shape = _any;
          }
        }else{
            if(_keep != null){
              _screen.set_offscreen_mode (false);
              _keep.draw(_screen,null);
              _screen.set_offscreen_mode (true);
              _keep = null;
              _draw_shape = null;
            }
        }
      }catch(Exception ee){
      }
    }

  /**
   * CxgŎ擾}`IuWFNgԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    _pg@}`IuWFNg
   */
    public psvShape getShape(){
       return _pg;
    }
  /**
   * O[v}`IuWFNg̑ݒ肵܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvGroup@}`O[v
   */
    protected psvGroup creategroup(){
      psvDrawContext dc = new psvDrawContext();
      dc.attrib(psvAttrib.VISIBLE|psvAttrib.DETECTIVE|psvAttrib.COLOR_GROUP);
      return new psvGroup(dc,null);
    }
  /**
   * }EXWԋ߂}`IuWFNgT܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    _sshape@}`IuWFNg
   */
    public psvShape nearshape(psvPoint n_p,Enumeration n_enu){
      psvShape _sshape = null;
      float _dis = Float.MAX_VALUE;
      for (; n_enu.hasMoreElements() ;) {
        psvShape _shape = (psvShape)n_enu.nextElement();
        if(_dis > _shape.distance(n_p.x,n_p.y)){
           _dis = _shape.distance(n_p.x,n_p.y);
           _sshape = _shape;
        }
      }
      return _sshape;
    }

  /**
   * I
   * <p>
   * <p>
   * @since
   * @return
   */
    public void close(){
        _canvas.repaint();
    }
}


