
package jp.co.melco.preserv.misc;

/*
  }`]\Cxg

  }EXWɈԋ߂}`Fς\܂B
  ύXΏې}`hbMO邱ƂŐ}`]\܂B

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B
  
  copyright(c) MITSUBISHI ELECTRIC CORPORATION
  
*/

import java.awt.*;
import java.awt.event.MouseEvent ;

import jp.co.melco.preserv.*;

/**
 *}`]CxgB
 */
public class Ev_Shape_Rotate extends Ev_Default_Mouse
{
    private Ac_Mouse_IF _ac ;
    private Mg_Information_IF _info;
    private Component _canvas;
    private psvJavaScreen _screen;
    private psvMdmMapEx _mdm_map;
    private psvPoint _p,_p2 ;
    private psvShape _clone_shape;
    private psvShape _drag_shape;
    private psvShape _old_shape;
    psvPoint shape_p = null;
    int _motion=0;
    float _start_degree=0;


  /**
   * }`]CxgIuWFNg\z܂B
   * <p>
   * @param    
   * <p>
   * @since
   * @return
   */
    public Ev_Shape_Rotate()
    {
    }


  /**
   * }`]CxgIuWFNg\z܂B
   * <p>
   * @param    Ac_Mouse_IF  ANVCxg
   * <p>
   * @since
   * @return
   */
    public Ev_Shape_Rotate(Ac_Mouse_IF ac)
    {
	    _ac = ac ;
            _info = _ac.getInformation();
            _canvas = _info.get_canvas();
            _screen = _info.get_screen();
            _mdm_map = _info.get_map();
    }

  /**
   * ANVNXݒ肵܂B
   * <p>
   * @param    Ac_Mouse_IF  ANVCxg
   * <p>
   * @since
   * @return
   */
    public void setAction(Ac_Mouse_IF ac)
    {
	    _ac = ac ;
            _info = _ac.getInformation();
            _canvas = _info.get_canvas();
            _screen = _info.get_screen();
            _mdm_map = _info.get_map();
    }


  /**
   * }EXEvXCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mousePressed(MouseEvent e)
    {
      if(_drag_shape != null){
         _p2 = _screen.dc_to_wc(e.getX(),e.getY());

         psvPoint shape_p = new psvPoint(_drag_shape.cx(),_drag_shape.cy());

         _start_degree = psvArcData.get_degree(shape_p,_p2);

         _motion = 1;  
      }
    }

  /**
   * }EXE[XCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mouseReleased(MouseEvent e)
    {
        if(_motion == 1 && _drag_shape != null){
          setActionState(true);
          _ac.mouseReleased(this);
        }
          _drag_shape = null;
          _start_degree = 0;
          _motion = 0;
          _p = null;shape_p  = null;
    }

  /**
   * }EXEhbOCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    
    public void mouseDragged(MouseEvent e)
    {
       if(_motion == 1){
        try{
          _screen.set_offscreen_mode (false);          
          _screen.set_raster (psvJavaScreen.GXxor,true);    
          psvColor colback = _drag_shape.get_context().get_color();
          _drag_shape.get_context().set_color(new psvColor(Color.green));
          _drag_shape.draw (_screen,null);

          _p2 = _screen.dc_to_wc(e.getX(),e.getY());
          
          if(shape_p == null)
            shape_p = new psvPoint(_drag_shape.cx(),_drag_shape.cy());
          
          float degree = psvArcData.get_degree(shape_p,_p2);

          float deg = (degree - _start_degree) < 0 ? 360.0f + (degree - _start_degree) : (degree - _start_degree);

          _drag_shape.rotate(shape_p.x,shape_p.y,(int)(deg*10),null,true);
          _drag_shape.draw(_screen,null);
          _drag_shape.get_context().set_color(colback);
          _screen.set_raster(psvJavaScreen.GXcopy, true) ;
	  _screen.set_offscreen_mode(true) ;
          _start_degree = degree;
          _p = _p2;
         }catch(Exception ee){
          _screen.set_raster(psvJavaScreen.GXcopy, true) ;
	  _screen.set_offscreen_mode(true) ;
         }
        }
    
    }

  /**
   * }EXE[uCxgB
   * <p>
   * @param    MouseEvent   }EXCxg
   * <p>
   * @since
   * @return
   */
    public void mouseMoved(MouseEvent e)
    {
       if(_motion == 0){
        try{
          _screen.set_offscreen_mode (false);
          _p = _screen.dc_to_wc (e.getX(),e.getY());

          if(_drag_shape != null)
           _drag_shape.draw (_screen,null);

          _drag_shape = (psvShape)_mdm_map.search_nearest(_p.x,_p.y,null,null,true);
          _drag_shape.draw(_screen, new psvColor(Color.magenta), false);
          _screen.set_offscreen_mode (true);
        }catch(Exception ee){
          _screen.set_offscreen_mode (true);
        }
       }
    }

  /**
   * CxgŎ擾}`IuWFNgԂ܂B
   * <p>
   * @param
   * <p>
   * @since
   * @return    psvShape@}`IuWFNg
   */
    public psvShape getShape(){
       return _drag_shape;
    }

  /**
   * I
   * <p>
   * <p>
   * @since
   * @return
   */
    public void close(){}


}

